<?php


    #####################################
    #
    #   include the files needed
    #
    require_once('../../libs/simpletemplate/Engine.php');
    require_once('../../libs/simpletemplate/Filter/Basic.php');

    #####################################
    #
    #   make template class instance
    #
    $options = array(   'templateDir'   => dirname(__FILE__),
                        'compileDir'    => 'tmp',   // use the compile dir 'tmp' under the tempalte dir
                        // or use the following line to specifiy a complete path
                        //'compileDir'    => $DOCUMENT_ROOT.'/libs/php/SimpleTemplate/examples/simple/tmp',

                        'verbose'   => true,    // this is default too
                        'locale'    => '',      // there is no language stuff here
                        'logLevel'  => 1,       // write log-file

                        // let me define the filters i want to use
                        'filterLevel'   => 0    // level 0 means no filter by default
                        );
    $tpl = new SimpleTemplate_Engine($options);



    #####################################
    #
    #   make filter class instance
    #   and apply filters as needed
    #
    $tplFilter = new SimpleTemplate_Filter_Basic($tpl->getOptions());
    // pre filter
    $tpl->registerPrefilter(array(&$tplFilter,'removeHtmlComments'));
    $tpl->registerPrefilter(array(&$tplFilter,'removeCStyleComments'));
    $tpl->registerPrefilter(array(&$tplFilter,'addIfBeforeForeach'));   // this filter makes the foreach-blocks conditional, so they are only shown if they contain data, see api-doc
    // post filter
    $tpl->registerPostfilter(array(&$tplFilter,'trimLines'));
    $tpl->registerPostfilter(array(&$tplFilter,'optimizeHtmlCode'));


	// Benchmark vars
	for($x = 0; $x < 50; $x++) {
		$foo[] = 'bar_'.$x;
	}

    #####################################
    #
    #   show the template
    #
    $tpl->compile('index.tpl');
    include($tpl->getCompiledTemplate());
?>