<html>
<body bgcolor="#cccccc">
<h1>Smarty Benchmarks</h1>
<p>
<h2>Overview:</h2><p>
The following Smarty benchmarks are executed in real time. Each iteration is
fetched through port 80 on the web server, so the benchmark times you see
include aspects like server connection, script execution, etc... basically
everything a browser would see minus network latency. This method of
benchmarking should be a fair depiction of the template engine comparisons.
Depending on server traffic, file regeneration, etc. you may see varying
results. Many of the engines are extremely close in speed, so try reloading the
benchmarks a few times to get a sense of accuracy.

<p>
You can grab the sources of these benchmarks <a
href="smarty-benchmark.tar.gz">here</a>.<br>

<pre>
<b>How to install:</b> (replace "nobody" with web server user)

gtar -xvf smarty-benchmark.tar.gz
chown nobody:nobody smarty-benchmark/*/*/templates_c/
chown nobody:nobody smarty-benchmark/*/*/cache/
</pre>

<p>
<a href="http://www.php-accelerator.co.uk/">php-accelerator</a> is used on this
web server. All of the template engines take advantage of the compilation
caching. No server should be without one :-) If you want to view the benchmarks
without php-accelerator, prepend /no-cache/ to the URL just after the server
name.

<p>
I tried my best to setup each template engine efficiently. If you see any problems
or a way to do something better, feel free to send me an e-mail: monte at ispi
dot net.
<p>
Smarty is benchmarked with and without the cache enabled. These examples don't
do the caching feature much justice since variable assignment is not coming
from an expensive operation, such as a db query. The templates are also not so
complex, it doesn't take much longer to parse the template than it does to
fetch a cached copy.

<p>
ModeliXe is used with its caching feature turned on. I'm not sure how to
disable it, but since it is on by default I left it alone.
<p>


<p>
<b>Benchmark: var_assign</b>
<p>
Each iteration of the <b>var_assign</b> benchmark assigns 50 template variables
and parses/fetches the template. This is mixed with other text, as you can see
in this <a href="benchmark_var_assign/smarty/index.php">example output</a>.
<p>

<a href="benchmark_var_assign.php?i=10">var_assign 10 iterations</a><br>
<a href="benchmark_var_assign.php?i=25">var_assign 25 iterations</a><br>
<a href="benchmark_var_assign.php?i=50">var_assign 50 iterations</a><br>

<p>
<b>Benchmark: var_loop</b>
<p>
Each iteration of the <b>var_loop</b> benchmark loop through a block 50 times
and displays a template variable. This is mixed with other text, as you can see
in this <a href="benchmark_var_loop/smarty/index.php">example output</a>.
<p>
I was unable to figure out <b>ultratemplate</b> and <b>pattemplate</b> variable
looping, so they are left out of this benchmark. If someone would like to
create these benchmarks, I'll be glad to add them.
<p>

<a href="benchmark_var_loop.php?i=10">var_loop 10 iterations</a><br>
<a href="benchmark_var_loop.php?i=25">var_loop 25 iterations</a><br>
<a href="benchmark_var_loop.php?i=50">var_loop 50 iterations</a><br>
</body>
</html>
