<?php
/*
  NAME:	ULTRATEMPLATE CLASS 2.4.0
  BY:	CHRISTOPHER BROWN-FLOYD
  DATE:	May 21, 2002
  SITE: http://www.ultratemplate.com/
  EMAIL LIST: ultratemplate-list@bfworld.com
  
  
  CHANGELOG:
  
  Set variables to be parsed before file names.
  
*/
class UltraTemplate
{
	var $leftdelim = "<";
	var $rightdelim = ">";
	var $lefttag = Array("tag:","template:");
	var $righttag = Array("/","/template:");
	var $_TEMPLATES_ = Array("");
	var $global_vars = "";
	var $global_var_list = "";
	var $currenttagname = "";
	var $processingtemplate = false;
	var $cache_path="./cache";
	var $cache_page=false;
	var $cache_page_name="";
	var $cache_page_length=-1;
	var $cache_page_unit="i";
	
	var $_CACHEUNITS_ = Array(
									"s"=>1,
									"m"=>60,
									"h"=>3600,
									"d"=>86400,
									"i"=>-1
									);

	function UltraTemplate()
	{
		if (!defined("DATATAG"))
		{
			define("DATATAG",0);
			define("TEMPLATETAG",1);
			define("NEWLINE","\r\n");
			define("TABCHAR",chr(9));
			define("HIDDENCHAR",chr(1));
			define("NOTAG",3);
			define("NORMALTAG",2);
			define("COMPOUNDTAG",1);
		}
	}




	function tag($__key__,$__value__="")
	{
		if (IsSet($this->display_page_cache))
			return;
		$templatepointer = &$this->currenttemplate;
		$templates = &$this->_TEMPLATES_;
		eval($this->global_vars);
		
		if (is_array($__key__))
		{
			reset ($__key__);
		}
		else
		{
			$tagname = &$__key__;
			$tagvalue = &$__value__;
		}
		
		while ((is_array($__key__) && (list($tagname, $tagvalue) = each ($__key__))) || !is_array($__key__))
		{
			$lefttag = $this->leftdelim.$this->lefttag[DATATAG].$tagname;
			$lefttaglen = strlen($lefttag);
			$lefttagend = 0;
			$this->currenttagname = &$tagname;
			$cache_enabled = false;

			while ($lefttagend >=0 && is_integer(strpos($templatepointer,$lefttag,$lefttagend)) && !empty($tagname))
			{
				$tagstart = strpos($templatepointer,$lefttag,$lefttagend);
				$lefttagend = $this->get_tag_end($tagstart+$lefttaglen);
				$tnstart = strpos($templatepointer,":",$tagstart+strlen($this->leftdelim))+1;
				$tntest = $this->get_tag_name($tnstart);
				
				if ($tntest == $tagname)
				{
					$condition = $this->get_condition($tagstart,$lefttagend);
					if ($condition)
					{
						$cache = $this->get_parameter("cache",$tagstart,$lefttagend);
						$cacheLength = $this->exec_parameter("cacheLength",$tagstart,$lefttagend);
						$cacheName = $this->exec_parameter("cacheName",$tagstart,$lefttagend);
						$cacheUnit = $this->exec_parameter("cacheUnit",$tagstart,$lefttagend);
						$cache=(is_null($cache))?(false):($cache);
						(int) $cacheLength = (is_null($cacheLength))?(-1):($cacheLength);
						if (is_null($cacheUnit))
							$cacheUnit = "i";
						if (is_null($cacheName))
							$cacheName = $tagname;
						if ($cacheUnit=="i" && $cacheLength>0)
							$cacheUnit="h";
						if (!$this->cached($cacheName) || !$cache)
						{
							$as = $this->get_parameter("as",$tagstart,$lefttagend);
							$template = $this->get_parameter("template",$tagstart,$lefttagend);
							$falseValue = $this->get_parameter("falseValue",$tagstart,$lefttagend);
							$defaultValue = $this->get_parameter("defaultValue",$tagstart,$lefttagend);
							$label = $this->get_parameter("label",$tagstart,$lefttagend);
							$src = $this->get_parameter("src",$tagstart,$lefttagend);
							$loop = $this->exec_parameter("loop",$tagstart,$lefttagend);
							if (substr($template,0,4)=="tpl:")
							{
								if (!IsSet($templates[substr($template,4)]))
								{
									if (!$this->parse_subtemplate(substr($template,4)))
										die("<b>Error: No template.</b><br />(Tag: $tagname)");
								}
								$template = &$templates[substr($template,4)];
							}
							else if (!is_null($template))
							{
								$template = $this->fetch($template);
							}
							switch($as)
							{
							case "img":
							case "hr":
							case "br":
							case "input":
								$tagtype = COMPOUNDTAG;
								break;
							case "label":
								$as="span";
								break;
							case "panel":
								$as="div";
								break;
							case "link":
								$as="a";
								break;
							case "banner":
								$as=null;
								$this->get_current_banner($tagvalue);
								break;
							case "repeater":
								$as=null;
								$repeater = new UltraRepeater();
								$repeater->id = $tagname;
								$repeater->template = $template;
								$repeater->saveDataStore($tagvalue);
								$repeater->execute();
								$tagvalue = &$repeater->output;
							}
							if (!IsSet($tagtype))
								$tagtype = (is_null($as))?(NOTAG):(NORMALTAG);
							$tag = substr($templatepointer,$tagstart+$lefttaglen,$lefttagend-($tagstart+$lefttaglen));
							$this->remove_whitespace($tag);
							
							switch($tagtype)
							{
							case COMPOUNDTAG:
								switch ($as)
								{
								case "img":
									$output = "<img src=\"$tagvalue".trim("\" $tag")." />";
									break 2;
								case "input":
									$output = "<input value=\"$tagvalue".trim("\" $tag")." />";
									break 2;
								default:
									$output = "<".trim("$as $tag")." />";
									break 2;
								}
							case NORMALTAG:
								switch($as)
								{
								case "a":
									$output = "<a href=\"$tagvalue".trim("\" $tag").">$label</a>";
									break 2;
								case "jsbutton":
									$output = "<input type=\"button\" value=\"$label\" onClick=\"$tagvalue".trim("\" $tag").">";
									break 2;
								case "imgbutton":
									$output = "<a href=\"$tagvalue\"><img src=\"$src".trim("\" $tag")."></a>";
									break 2;
								case "jsimgbutton":
									$output = "<a href=\"javascript:$tagvalue\"><img src=\"$src".trim("\" $tag")."></a>";
									break 2;
								default:
									$output = "<".trim("$as $tag").">$tagvalue</$as>";
									break 2;
								}
							case NOTAG:
								if (!IsSet($repeater) && !is_null($template))
								{
									$output = str_replace("\$field(0)",$tagvalue,$template);
								}
								else
								{
									$output = $tagvalue;
								}
								break;
							}
							if (!is_null($loop))
								$output = str_repeat($output,$loop);
							if ($cache)
							{
								$this->cache($cacheName,$output,$cacheLength,$cacheUnit);
							}
						}
						else
						{
							$output = &$this->fetch($this->cache_path."/".$cacheName.".cache");
						}
						$this->remove_tag($tagstart,$lefttagend,$output);
						$repeater = null;
					}
				}
			}
			
				
			if (!is_array($__key__))
				break;
		}
	}




	function parse_subtemplate(&$templatename)
	{
		$leftdelim = &$this->leftdelim;
		$rightdelim = &$this->rightdelim;
		$templatepointer = &$this->currenttemplate;
		$lefttag = $leftdelim.$this->lefttag[TEMPLATETAG].$templatename;
		$righttag = $leftdelim.$this->righttag[TEMPLATETAG].$templatename.$rightdelim;
		$lefttaglen = strlen($lefttag);
		$templates = &$this->_TEMPLATES_;
		$gottemplate = false;
		$righttagend = 0;
		$this->processingtemplate = true;
		
		while ($righttagend >= 0 && $righttagend <= strlen($templatepointer) && is_integer(strpos($templatepointer,$lefttag,$righttagend)))
		{
			$templatestart = strpos($templatepointer,$lefttag,$righttagend);
			$templateend = strpos($templatepointer,$righttag,$templatestart);
			if (is_bool($templateend))
				break;
			$righttagend = strpos($templatepointer,$rightdelim,$templateend);
			$lefttagend = $this->get_tag_end($templatestart+$lefttaglen);
			$tntest = strpos($templatepointer,":",$templatestart+strlen($this->leftdelim))+1;
			$tnname = $this->get_tag_name($tntest);
			if ($tnname == $templatename)
			{
				$righttagrem = $righttagend;
				$condition = $this->get_condition($templatestart,$lefttagend);
				$templateend -= ($righttagrem-$righttagend);
				$lefttagend -= ($righttagrem-$righttagend);
				if (!$condition)
				{
					$this->remove_tag($templatestart,$righttagend);
				}
				else
				{
					$templates[$templatename] = ($lefttagend != ($templateend-1))?(substr($templatepointer,$lefttagend+1,$templateend-$lefttagend-1)):("");
					$this->remove_tag($templatestart,$righttagend);
					$gottemplate = true;
				}
			}
		}
		return $gottemplate;
	}




	function get_condition(&$start,&$end)
	{
		eval($this->global_vars);
		$condition = $this->get_parameter("if",$start,$end);
		if (is_null($condition))
			return true;
		$condition = "\$condition = ($condition);";
		eval($condition);
		return $condition;
	}




	function get_parameter($paramname,&$start,&$end)
	{
		$templatepointer = &$this->currenttemplate;
		$ppos = strpos($templatepointer,$paramname."=",$start);
		if ($ppos>=$end || is_bool($ppos))
			return null;
		$vpos = strpos($templatepointer,"\"",$ppos)+1;
		for ($counter = $vpos;$counter <= $end;$counter++)
		{
			$char = substr($templatepointer,$counter,1);
			switch($char)
			{
			case "\"":
				break 2;
			case "\\":
				$counter++;
				break;
			}
		}
		$parameter = substr($templatepointer,$vpos,$counter-$vpos);
		$templatepointer = substr_replace($templatepointer,"",$ppos,($counter-$ppos)+1);
		$end -= ($counter-$ppos)+1;
		return stripslashes($parameter);
	}




	function exec_parameter($paramname,&$start,&$end)
	{
		$paramValue = $this->get_parameter($paramname,$start,$end);
		$templates = &$this->_TEMPLATES_;

		eval($this->global_vars);

		if (substr($paramValue,0,1)=="$")
		{
			eval("\$paramValue = &$".substr($paramValue,1).";");
		}
		else if (substr($paramValue,0,1)=="!")
		{
			eval("\$paramValue = ".substr($paramValue,1).";");
		}
		else if (substr($paramValue,0,1)=="#")
		{
			eval("\$paramValue = &$".substr($paramValue,1).";");
			$setarray=false;
			while ($row=mysql_fetch_row($paramValue)) {
				$atagvalue[] = $row;
				$setarray=true;
			}
			$paramValue = ($setarray)?($atagvalue):(null);
		}
		else if (substr($paramValue,0,4)=="tpl:")
		{
			if (!IsSet($templates[substr($paramValue,4)]))
			{
				if (!$this->parse_subtemplate(substr($paramValue,4)))
					die("<b>Error: No inline template \"".substr($paramValue,4)."\" for parameter \"$paramname\" to include.</b><br />(Tag: ".$this->currenttagname.")");
			}
			$osubtemplate = new UltraTemplate();
			$osubtemplate->currenttemplate=&$templates[substr($paramValue,4)];
			$osubtemplate->setGlobalVars($this->global_var_list);
			$osubtemplate->bind();
			$templates[substr($paramValue,4)] = $osubtemplate->currenttemplate;
			$paramValue = &$templates[substr($paramValue,4)];
		}
		if (substr($paramValue,0,5)=="file:")
			$paramValue = $this->fetch(substr($paramValue,5));
		return $paramValue;
	}




	function get_tag_end($startpos)
	{
		$in_parameter = false;
		$templatepointer = &$this->currenttemplate;
		$templatelen = strlen($templatepointer);
		$rightdelim = &$this->rightdelim;
		
		for ($counter = $startpos;$counter <= $templatelen;$counter++)
		{
			$char = substr($templatepointer,$counter,strlen($rightdelim));
			if ($rightdelim==$char)
			{
				if (!$in_parameter)
				{
					return $counter;
				}
			}
			else if (substr($char,0,1) == "\"")
			{
				$in_parameter = !$in_parameter;
			}
			else if (substr($char,0,1) == "\\")
			{
				$counter++;
			}
		}
		return false;
	}




	function remove_tag(&$start,&$end,$output="")
	{
		$templatepointer = &$this->currenttemplate;
		$templatepointer = substr_replace($templatepointer,$output,$start,($end-$start)+strlen($this->rightdelim));
		$end -= ($end-$start)+strlen($this->rightdelim);
	}




	function remove_templates()
	{
		$templatepointer = &$this->currenttemplate;
		$leftdelim = &$this->leftdelim;
		$rightdelim = &$this->rightdelim;
		
		while (!is_bool(strpos($templatepointer,$leftdelim.$this->lefttag[TEMPLATETAG])))
		{
			$leftpos = strpos($templatepointer,$leftdelim.$this->lefttag[TEMPLATETAG]);
			$templatename = $this->get_tag_name($leftpos+strlen($leftdelim.$this->lefttag[TEMPLATETAG]));
			
			$rightpos = strpos($templatepointer,$rightdelim.$this->righttag[TEMPLATETAG].$templatename.$rightdelim);
			if (!is_bool($rightpos))
				$rightpos = $rightpos+strlen($leftdelim.$this->righttag[TEMPLATETAG].$templatename.$rightdelim);
			$templatepointer = substr_replace($templatepointer,"",$leftpos,($rightpos-$leftpos)+1);
		}
	}




	function remove_whitespace(&$tagpointer)
	{
		$tagpointer = str_replace(NEWLINE,HIDDENCHAR,$tagpointer);
		$tagpointer = str_replace(TABCHAR,HIDDENCHAR,$tagpointer);
		$tagpointer = ereg_replace(HIDDENCHAR."+"," ",$tagpointer);
		$tagpointer = trim($tagpointer);
		
		$tagpointer = preg_replace("/\/$/","",$tagpointer);
	}




	function bind()
	{
		if (!IsSet($this->display_page_cache))
		{
			eval($this->global_vars);
			$templatepointer = &$this->currenttemplate;
			$lefttag = $this->leftdelim.$this->lefttag[DATATAG];
			$lefttaglen = strlen($lefttag);
			$lefttagend = 0;
			
			while (is_integer(strpos($templatepointer,$lefttag,$lefttagend)))
			{
				$tagstart = strpos($templatepointer,$lefttag);
				$lefttagend = $this->get_tag_end($tagstart+$lefttaglen);
				$tagname = $this->get_tag_name($tagstart+$lefttaglen);
				$this->currenttagname = &$tagname;
				$condition = $this->get_condition($tagstart,$lefttagend);
				$tagvalue="";
				if (!$condition)
				{
					if (!$this->cached($tagname))
					{
						$falseValue = $this->exec_parameter("falseValue",$tagstart,$lefttagend);
						if (is_null($falseValue))
							$this->remove_tag($tagstart,$lefttagend);
						$tagvalue = &$falseValue;
					}
					$this->tag($tagname,$tagvalue);
				}
				else
				{
					if (!$this->cached($tagname))
					{
						$defaultValue = $this->exec_parameter("defaultValue",$tagstart,$lefttagend);
						$tagvalue = &$defaultValue;
					}
					$this->tag($tagname,$tagvalue);
				}
			}
		}
	}




	function get_tag_name($start)
	{
		$templatepointer = &$this->currenttemplate;
		$end = $start;
		$asc = ord(substr($templatepointer,$start,1));
		while (($asc >= 65 && $asc <= 90) || ($asc >= 97 && $asc <= 122) || ($asc >= 48 && $asc <= 57) || $asc == 95 || $asc == 45 || $asc == 46)
		{
			$end++;
			$asc = ord(substr($templatepointer,$end,1));
		}
		$tagname = substr($templatepointer,$start,$end-$start);
		return $tagname;
	}




 	//Loads a file into the template processor
	function load($path)
 	{
  		if ($this->cache_page && empty($this->cache_page_name))
  		{
  			$arrfile = explode("/",$path);
  			$arrname = explode(".",$arrfile[sizeof($arrfile)-1]);
  			$name = $arrname[0];
  			$this->cache_page_name = $name;
  		}
  		
  		if ($this->cache_page && $this->cached($this->cache_page_name))
  		{
  			$this->display_page_cache = true;
  		}
  		else
  		{
  			if ($this->cache_page && $this->cache_page_unit=="i" && $this->cache_page_unit>0)
  				$this->cache_page_unit = "h";
	  		$this->currenttemplate = $this->fetch($path);
  		}
 	}




 	//Returns a file as a string
 	function fetch($path)
 	{
  		$template = "";
  		$READFILE = "r";
  		if (file_exists($path))
  		{
   			$fp = fopen($path,$READFILE);
   			if (!feof($fp))
   			{
    				$template = fread($fp,filesize($path));
   			}
   			fclose($fp);
  		}
  		return $template;
 	}



	function cache(&$filename,&$data,&$cache_length,$cache_unit="i")
	{
		if (!is_dir($this->cache_path))
			mkdir($this->cache_path,0766);
		if (!$this->cached($filename))
		{
			$filename = $this->cache_path."/".$filename;
			$this->saveas($filename.".cache",$data);
			$this->saveas($filename.".cfg",
				$this->get_time().":".$cache_length.":".$cache_unit);
		}
	}



	function delete_cache($filename="")
	{
		if (empty($filename))
		{
			rmdir($this->cache_path);
		}
		else
		{
			unlink($this->cachepath."/".$filename.".cache");
			unlink($this->cachepath."/".$filename.".cfg");
		}
	}



	function cached(&$filename)
	{
		if (is_file($this->cache_path."/".$filename.".cache") && is_file($this->cache_path."/".$filename.".cfg"))
		{
			$cache_params = explode(":",$this->fetch($this->cache_path."/".$filename.".cfg"));
			if ($cache_params[2]=="i")
				return true;
			if (($this->get_time()-$cache_params[0])>=($this->_CACHEUNITS_[$cache_params[2]]*$cache_params[1]))
			{
				return false;
			}
			return true;
		}
		else
		{
			return false;
		}
	}



	function get_time()
	{
	    list($usec, $sec) = explode(" ",microtime()); 
	    return ((float)$usec + (float)$sec); 
	}


	 //display the template
	 function display()
	 {
	 	if ($this->cache_page && $this->cached($this->cache_page_name))
	 	{
	 		echo($this->fetch($this->cache_path."/".$this->cache_page_name.".cache"));
	 	}
	 	else
	 	{
			$this->remove_templates();
	 		echo($this->currenttemplate);
	 		
	 		if ($this->cache_page)
	 			$this->cache($this->cache_page_name,$this->currenttemplate,$this->cache_page_length,$this->cache_page_unit);
	 	}
	 }




	//Saves the current template
	function saveas($path,$data="",$WRITEFILE="w")
	{
		if (empty($data))
			$data = &$this->currenttemplate;
		$fp = fopen($path,$WRITEFILE);
		$fout = fwrite($fp,$data);
		fclose($fp);
	}




	//Append the current template to the specified file
	function appendto($path)
	{
		$this->saveas($path,"","a");
	}




	//Sets global variables for use in the template
	function setGlobalVars($vars)
	{
		$this->global_vars = "global \$" . str_replace(",",",\$",$vars) . ";";
		eval($this->global_vars);
		
		/*
		$arrayVars = explode(",",$vars);
		for ($i=0;$i<sizeof($arrayVars);$i++)
		{
			eval("\$this->$arrayVars[$i] = &\$$arrayVars[$i];");
		}
		*/

		$this->global_var_list = $vars;
	}




	function get_current_banner(&$banners)
	{
		$leftdelim = &$this->leftdelim;
		$rightdelim = &$this->rightdelim;
		$bannerleft = $leftdelim."banner".$rightdelim;
		$bannerright = $leftdelim."/banner".$rightdelim;
		$banners = trim($banners);
		if ($banners == "")
			return;
		$banners = str_replace("\r\n","\r",$banners);
		$banners = preg_replace("/".$bannerleft."[^<>]*".$bannerleft."/s",$bannerright,$banners);
		$banners = preg_replace("/".$bannerleft."[^a-z]*/si","",$banners);
		$banners = preg_replace("/".$bannerright."$/s","",$banners);
		$bannerarray = explode($bannerright,$banners);
		$current = 0;
		if (sizeof($bannerarray)>1)
			(int) $current = rand(0,sizeof($bannerarray)-1);
		$currentbanner = trim($bannerarray[$current]);
		$banneroptions = explode("\r",$currentbanner);
		$href = trim($banneroptions[0]);
		$image = trim($banneroptions[1]);
		$alt = trim($banneroptions[2]);
		$banners = "<a href=\"$href\"><img src=\"$image\" alt=\"$alt\" border=\"0\" /></a>";
	}
}




class UltraRepeater {

 var $id="table1";
 var $output="";
 var $template="";
 var $columndelimiter=",";
 var $rowdelimiter="\r\n";
 var $rows=0;
 var $columns=0;
 var $pagesize=0;
 var $page=0;
 var $datastore="";
 var $rowselect=0;
 var $columnselect=0;

 function saveDataStore($data) {
  if ($data==null || $data=="") {$this->datastore=null;return;}
  if (!is_array($data)) {
   $data = explode($this->rowdelimiter,$data);
   $atempdata = explode($this->columndelimiter,$data[0]);
   $ub2 = (is_array($atempdata))?(sizeof($atempdata)):(0);
   while ($row=each($data)) {
    $tempdata[] = explode($this->columndelimiter,$row[1]);
   }
  } else {
   $tempdata = $data;
  }
  $this->rows = sizeof($tempdata);
  $this->columns = sizeof($tempdata[0]);

  $this->datastore = $tempdata;
 }

 function mergeData() {
  $i=0;
  $j=0;
  $temptemplate="";
  $tempdata="";
  $rowcount=0;
  $rowselect=0;
  $rowtype[0]="evenrow";
  $rowtype[1]="oddrow";

  if (($this->datastore==null) || ($this->datastore=="")) {return "";}

  if ($this->template=="") {
   $tempdata = $this->makeTable();
  } else {
   $rowselect = 0;
   $columnselect = 0;
   if ($this->pagesize<1) {
    $this->pagesize=$this->rows;
    $top=0;
   } else {
    $top=($this->page>1)?(($this->page*$this->pagesize)-$this->pagesize):(0);
    $top=($top<0)?(0):($top);
   }
   for ($i=$top;$i<=$top+$this->pagesize-1;$i++) {
    $temptemplate = $this->template;
    for ($j=0;$j<=$this->columns-1;$j++) {
     $temptemplate = str_replace("\$field($j)",$this->datastore[$i][$j],$temptemplate);
    }
    $temptemplate = str_replace("\$rowtype",$this->id."_".$rowtype[$rowselect],$temptemplate);
    $temptemplate = str_replace("\$rownumber",$rowcount,$temptemplate);

    $tempdata .= $temptemplate;
    $rowselect = 1 ^ $rowselect;
    $rowcount++;
    if (($rowcount==$this->pagesize) || ($top+$rowcount==$this->rows)) {break;}
   }
  }
  return $tempdata;
 }

 function makeTable() {
  $rowcount=0;
  $rowselect=0;
  $rowtype[0]="evenrow";
  $rowtype[1]="oddrow";
  $columnselect=0;
  $columntype[0]="evencolumn";
  $columntype[1]="oddcolumn";

  if ($this->pagesize<1) {
   $this->pagesize=$this->rows;
   $top=0;
  } else {
   $top=($this->page>1)?(($this->page*$this->pagesize)-$this->pagesize):(0);
   $top=($top<0)?(0):($top);
  }

  $tempdata = "<table id=\"$this->id\">";

  for ($i=$top;$i<=$top+$this->pagesize-1;$i++) {
   $tempdata .= "<tr id=\"$this->id"."_row$i\" class=\"$this->id"."_"."$rowtype[$rowselect]\">";
   for ($j=0;$j<=$this->columns-1;$j++) {
    $tempdata .= "<td id=\"$this->id"."_row$i_column$j\" class=\"$this->id"."_$columntype[$columnselect]\">" . $this->datastore[$i][$j] . "</td>";
    $columnselect = 1 ^ $columnselect;
   }
   $tempdata.="</tr>";
   $rowselect = 1 ^ $rowselect;
   $rowcount++;
   if (($rowcount==$this->pagesize) || ($top+$rowcount==$this->rows)) {break;}
  }
  return $tempdata."</table>";
 }

 function execute() {
  $this->output = $this->mergeData();
 }
}
?>
